﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Tools
Imports Syncfusion.Windows.Forms


Namespace GridBag
    Partial Public Class Form1
        Inherits MetroForm
        Private _Quantities() As CheckBox
        Private _Names() As Label
        ' From SyncFusion WinForms Library
        Private _Toggle() As ToggleButton
        Private Beleren As New Font("Beleren", 10, FontStyle.Regular)
        Private IDInset As New Insets(5, 5, 5, 5)
        Private QuantityInset As New Insets(5, 5, 5, 5)
        Private NameInset As New Insets(0, 5, 0, 5)
        Private ToggleInset As New Insets(0, 0, 0, 0)
        Public Sub New()
            InitializeComponent()
            Generate()
        End Sub

        Public Property Quantities() As CheckBox()
            Get
                Return _Quantities
            End Get
            Set(ByVal value As CheckBox())
                _Quantities = value
            End Set
        End Property

        Public Property Names() As Label()
            Get
                Return _Names
            End Get
            Set(ByVal value As Label())
                _Names = value
            End Set
        End Property

        Public Property Toggles() As ToggleButton()
            Get
                Return _Toggle
            End Get
            Set(ByVal value As ToggleButton())
                _Toggle = value
            End Set
        End Property

        Public Sub Generate()
            SuspendLayout()
            For i% = 2 To 31
                AddNewCtrls(i, vbNullString, False, i, i - 1)
                AddNewCtrls(i + 30, vbNullString, False, i + 4, i - 1)
                AddNewCtrls(i + 60, vbNullString, False, i + 8, i - 1)
                AddNewCtrls(i + 90, vbNullString, False, i + 12, i - 1)
            Next i
            ResumeLayout()
            Refresh()
            PerformLayout()
        End Sub

        Public Function AddNewCtrls(IDNum%, CtrlName$, CtrlEnabled As Boolean, GridX%, GridY%) As Object

            Dim NewCtrlQuantity As New CheckBox, NewCtrlID, NewCtrlName As New Label, NewCtrlToggle As New ToggleButton
            Try
                NewCtrlID.Font = Beleren
                NewCtrlID.Text = IDNum
                NewCtrlID.Tag = IDNum
                NewCtrlID.Name = "lbl" & IDNum
                NewCtrlID.TextAlign = ContentAlignment.MiddleCenter
                NewCtrlID.AutoSize = True
                Me.gridBagLayout1.SetConstraints(NewCtrlID, New GridBagConstraints(GridX, GridY, 1, 1, 0.0, 0.0, AnchorTypes.Center, FillType.None, IDInset, 0, 0, False))

                NewCtrlQuantity.Text = "400"
                NewCtrlQuantity.Name = "cbCount" & IDNum
                NewCtrlQuantity.Tag = IDNum
                NewCtrlQuantity.FlatStyle = FlatStyle.Flat
                NewCtrlQuantity.Appearance = System.Windows.Forms.Appearance.Button
                NewCtrlQuantity.MaximumSize = New Size(60, 25)
                NewCtrlQuantity.MinimumSize = New Size(60, 25)
                NewCtrlQuantity.AutoSize = True
                Me.gridBagLayout1.SetConstraints(NewCtrlQuantity, New GridBagConstraints((GridX + 1), GridY, 1, 1, 0.0, 0.0, AnchorTypes.Center, FillType.None, QuantityInset, 0, 0, False))

                NewCtrlName.Text = CtrlName
                NewCtrlName.Name = "lblAssign" & IDNum
                NewCtrlName.Tag = IDNum
                NewCtrlName.MaximumSize = New Size(160, 25)
                NewCtrlName.AutoSize = True
                NewCtrlName.AutoEllipsis = True
                NewCtrlName.TextAlign = ContentAlignment.MiddleCenter
                Me.gridBagLayout1.SetConstraints(NewCtrlName, New GridBagConstraints((GridX + 2), GridY, 1, 1, 0.0, 0.0, AnchorTypes.Center, FillType.None, NameInset, 0, 0, False))

                NewCtrlToggle.Text = ""
                NewCtrlToggle.Name = "cbMask" & IDNum
                NewCtrlToggle.Tag = IDNum
                NewCtrlToggle.MaximumSize = New Size(25, 25)
                NewCtrlToggle.MinimumSize = New Size(25, 25)
                Me.gridBagLayout1.SetConstraints(NewCtrlToggle, New GridBagConstraints((GridX + 3), GridY, 1, 1, 0.0, 0.0, AnchorTypes.Center, FillType.None, ToggleInset, 0, 0, False))

                Controls.AddRange(New Control() {NewCtrlID, NewCtrlQuantity, NewCtrlName, NewCtrlToggle})
            Catch ex As Exception
                'LogException(ex)
                Return False
            End Try

            Return True

        End Function
    End Class
End Namespace
